# Copyright 2019 (c) Anna Schumaker.
from . import playlist
from .. import tree

ALBUM_ICON  =   "media-optical-cd-audio"
ALBUM_SORT  = [ "discnumber", "tracknumber" ]

ARTIST_ICON =   "avatar-default-symbolic"
ARTIST_SORT = [ "album", "discnumber", "tracknumber" ]


class ArtistPlaylist(playlist.Playlist):
    def alloc_child(self, name):
        return playlist.Playlist(name, ALBUM_ICON, ALBUM_SORT)

    def add(self, track):
        playlist.Playlist.add(self, track)
        self.lookup(track["album"]).add(track)


class ArtistNode(tree.ETree):
    def __init__(self):
        tree.ETree.__init__(self, "Artists", ARTIST_ICON)

    def alloc_child(self, name):
        return ArtistPlaylist(name, ARTIST_ICON, ARTIST_SORT)

    def new_track(self, track):
        self.lookup(track["albumartist"]).add(track)
