# Copyright 2019 (c) Anna Schumaker.
from . import playlist
from .. import tree

DECADE_ICON =   "x-office-calendar"
DECADE_SORT = [ "date", "artist", "album", "discnumber", "tracknumber" ]

YEAR_ICON   =   "x-office-calendar"
YEAR_SORT   = [ "artist", "album", "discnumber", "tracknumber" ]


class DecadePlaylist(playlist.Playlist):
    def alloc_child(self, name):
        return playlist.Playlist(name, YEAR_ICON, YEAR_SORT)

    def add(self, track):
        playlist.Playlist.add(self, track)
        self.lookup(str(track["date"])).add(track)


class DecadeNode(tree.ETree):
    def __init__(self):
        tree.ETree.__init__(self, "Decades", DECADE_ICON)

    def alloc_child(self, name):
        return DecadePlaylist(name, DECADE_ICON, DECADE_SORT)

    def new_track(self, track):
        self.lookup(track.decade()).add(track)
