# Copyright 2019 (c) Anna Schumaker.
from . import playlist
from . import user
from .. import trak
import os
import unittest

test_album = os.path.abspath("./trier/Test Album")

class TestNewPlaylist(unittest.TestCase):
    def test_new_plist(self):
        plist = user.NewPlaylist()
        self.assertIsInstance(plist, playlist.Playlist)
        self.assertEqual(plist.name, "New Tracks")
        self.assertEqual(plist.icon, "document-new")
        self.assertEqual(plist.sort_order,
                    [ "artist", "date", "album", "discnumber", "tracknumber" ])

    def test_new_plist_new_track(self):
        plist = user.NewPlaylist()
        self.assertEqual(len(plist), 0)

        track = trak.lookup(os.path.join(test_album, "01 - Test Track.ogg"))
        self.assertEqual(len(plist), 1)
        self.assertEqual(plist[0],   track)

    def test_new_plist_get_state(self):
        plist = user.NewPlaylist()
        track = trak.lookup(os.path.join(test_album, "01 - Test Track 01.ogg"))

        plist.add(track)
        plist.current = 3

        state = plist.__getstate__()
        self.assertEqual(state["name"], "New Tracks")
        self.assertEqual(state["icon"], "document-new")
        self.assertEqual(state["list"], [ ])
        self.assertEqual(state["current"], -1)
