# Copyright 2019 (c) Anna Schumaker.
from . import playlist
from .. import tree

NEW_ICON  =   "document-new"
NEW_SORT  = [ "artist", "date", "album", "discnumber", "tracknumber" ]

STAR_ICON =   "starred"
STAR_SORT = [ "artist", "date", "album", "discnumber", "tracknumber" ]


class NewPlaylist(playlist.Playlist):
    def __init__(self):
        playlist.Playlist.__init__(self, "New Tracks", NEW_ICON, NEW_SORT)

    def __getstate__(self):
        state = playlist.Playlist.__getstate__(self)
        state["list"] = [ ]
        state["current"] = -1
        return state

    def new_track(self, track):
        self.add(track)


class UserNode(tree.ETree):
    def __init__(self):
        tree.ETree.__init__(self, "Playlists", "audio-x-generic")
        self.insert_child(NewPlaylist())
        self.insert_child(playlist.Playlist("Starred", STAR_ICON, STAR_SORT))

    def reset(self):
        tree.ETree.reset(self)
        self.insert_child(NewPlaylist())
        self.insert_child(playlist.Playlist("Starred", STAR_ICON, STAR_SORT))
